/*
	NumDigitsCmd.cc

	Will Eighteen, 2000: will@opaline.demon.co.uk
*/

#include "NumDigitsCmd.h"
#include "Application.h"
#include <LineEdit.h>

#include "OpResources.h"	// this is the only resources file with global resources

NumDigitsCmd::NumDigitsCmd ( const char *name, int active ) :  Cmd ( name, active )
{
	_popupRealised = False;
}


void NumDigitsCmd::doCommand()
{
	if ( _popupRealised == True )
		return;

	char buf[30];
	
	_edit = new LineEdit ( ( char * ) name(), TRUE,
									&NumDigitsCmd::enterCallback,
									&NumDigitsCmd::cancelCallback, ( void * ) this );	
	
	/* retrieve resource to be displayed */
 	snprintf ( buf, sizeof ( buf ), "%d", mixwaveResources->numDigits());
	buf [ sizeof ( buf ) - 1 ] = 0;
	_edit->setColumns ( strlen ( buf ) );	// set width before instantiation
	_edit->setHelp ( "Maximum number of digits to display." );
	_edit->execute();
	_edit->setText ( buf );	// can't set text before instantiation...
	_popupRealised = True;
}


void NumDigitsCmd::undoCommand()
{
	// not implemented
}


void NumDigitsCmd::enterCallback ( void *clientData, char *text )
{
	int num;

	NumDigitsCmd *obj = ( NumDigitsCmd * ) clientData;
	sscanf ( text, "%d", &num );	

	if ( num >= 0 )
		obj->enter ( num );

	obj->_popupRealised = False;
	delete obj->_edit;
}

/* specify resource to be set on 'enter' or 'ok' */
void NumDigitsCmd::enter ( int num )
{
	mixwaveResources->numDigits ( num );
}


void NumDigitsCmd::cancelCallback ( void *clientData )
{
	NumDigitsCmd *obj = ( NumDigitsCmd * ) clientData;
	
	obj->_popupRealised = False;
	delete obj->_edit;
}
