// waveclass: example of block load, process and save

#include "waveclass.cc"

int main(void)
{  
   char *cData;
   WaveData *pWave;
   WaveData *pSave;
   string filename;
   int i; 				// what else?! 
   unsigned int j;
   int keepLooping = 1;
   char opName;
   long blockSize;	// global control of space allocated to multiple files
                  	// e.g. for mixdown
  
   while (keepLooping)
   {
      cout << "(L)oad (S)ave (D)isplay (N)ext (Q)uit\n";
      cin >> opName;
   
      switch(opName)
      {
      	case 'l':
         case 'L':
            pWave = new WaveData;
            
            cout << "filename? \n";
            cin >> filename;
        
         	if(!pWave->LoadHeader(filename))
            {
            	cout << "error loading " << filename << "\n";
            }
            else
            {
            	pWave->filePos = 0;
               blockSize = 65536;

               pSave = new WaveData;	// new instance for (processed) wave
               // next set up dummy header for new wave file
               pSave->FillHeader(1, 44100, 16, pWave->totalSamples());

               // pSave->GetDataLength() has (fixed) data: pWave->ditto 
               // doesn't - due to the operation of AppendBlock on pWave
               pSave->SaveHeader("tmp.wav");  // dummy header written          
                           	
   	       	while (pWave->filePos < pSave->dataLength())
               {
                  if((pSave->dataLength() - pWave->filePos) < blockSize)
                     blockSize = pSave->dataLength() - pWave->filePos;                                 

               	pWave->LoadBlock(pWave->filePos, blockSize);
                  // PROCESSING can now take place! - see waveclass.ex1.cc
                  // for data handling method
                  pWave->AppendBlock("tmp.wav", 1, 44100, 16, blockSize>>1);
                  pWave->filePos += blockSize;           
               }               
            }
            
            // overwrite header with modified data length, etc, after editing
//         	pSave->ChangeHeader("tmp.wav");
         	break;
   
      	case 's':
         case 'S':
            // n.b. this only saves a complete file from memory
            cout << "filename? \n";
            cin >> filename;

         	if (!pWave->SaveWav(filename))
               cout << "error loading " << filename << "\n";
            else
               pWave->display();

      	case 'd':
         case 'D':
            pWave->display();
            break;
                           
         case 'n':
         case 'N':
            pWave = pWave->next();
            
            if (pWave == NULL)
               pWave = pWave->first();
               
            pWave->display();               
            break;
      
         case 'q':
         case 'Q':
            keepLooping = 0;
            break;
         
         default:;
      }
   }

   for (pWave = pWave->first(); pWave; pWave = pWave->next())
      delete pWave;	// delete pWave, pSave, other instances, ...
      
   return 0;
}

